-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Vector Map - Dynamic Viewport
This demo illustrates how to change the map's viewport. Use the drop-down menu under the map to choose a continent and change the visible area so that the chosen continent is displayed optimally.
To implement this functionality, call the viewport(viewportCoordinates) method every time the drop-down box value changes. You can also implement the onCenterChanged and onZoomFactorChanged functions to display the map center's coordinates and the current zoom factor in text boxes under the map.
Was this demo helpful?
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
const map = $('#vector-map').dxVectorMap({
layers: {
dataSource: DevExpress.viz.map.sources.world,
},
bounds: [-180, 85, 180, -60],
onZoomFactorChanged(e) {
zoomFactor.option('value', e.zoomFactor.toFixed(2));
},
onCenterChanged(e) {
center.option('value', `${e.center[0].toFixed(3)
}, ${e.center[1].toFixed(3)}`);
},
}).dxVectorMap('instance');
$('#switchPan').dxSwitch({
value: true,
onValueChanged: (e) => map.option('controlBar.panVisible', e.value),
});
$('#switchZoom').dxSwitch({
value: true,
onValueChanged: (e) => map.option('controlBar.zoomVisible', e.value),
});
$('#choose-continent').dxSelectBox({
dataSource: viewportCoordinates,
width: 210,
displayExpr: 'continent',
valueExpr: 'coordinates',
value: viewportCoordinates[0].coordinates,
inputAttr: { 'aria-label': 'Continent' },
onValueChanged(data) {
map.viewport(data.value);
},
});
const zoomFactor = $('#zoom-factor').dxTextBox({
width: 210,
readOnly: true,
inputAttr: { 'aria-label': 'Zoom' },
value: '1.00',
}).dxTextBox('instance');
const center = $('#center').dxTextBox({
width: 210,
readOnly: true,
inputAttr: { 'aria-label': 'Center' },
value: '0.000, 46.036',
}).dxTextBox('instance');
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" />
<script src="js/dx.all.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/world.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/africa.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/canada.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/eurasia.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/europe.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/usa.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="vector-map"></div>
<div class="options">
<div class="caption">Options</div>
<div class="wrapper-option">
<div class="column">
<div class="option">
<span>Continent</span>
<div id="choose-continent"></div>
</div>
<div class="option">
<span>Zoom factor</span>
<div id="zoom-factor"></div>
</div>
<div class="option">
<span>Center</span>
<div id="center"></div>
</div>
</div>
<div class="column">
<div class="option">
<span>Pan control</span>
<div id="switchPan"></div>
</div>
<div class="option">
<span>Zoom bar</span>
<div id="switchZoom"></div>
</div>
</div>
</div>
</div>
</div>
</body>
</html>
#vector-map {
height: 420px;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.wrapper-option {
display: flex;
gap: 24px;
padding-top: 16px;
}
.column {
display: flex;
gap: 10px;
flex-direction: column;
}
.option {
display: flex;
align-items: center;
min-height: 34px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > span {
width: 140px;
}
const viewportCoordinates = [{
continent: 'all',
coordinates: 'null',
}, {
continent: 'NorthAmerica',
coordinates: [-180, 84.52, -22.11, -1.57],
}, {
continent: 'SouthAmerica',
coordinates: [-112.47, 14.26, -27.52, -57.44],
}, {
continent: 'Africa',
coordinates: [-29.34, 39.09, 55.60, -39.00],
}, {
continent: 'Europe',
coordinates: [-2.35, 70.91, 61.35, 35.84],
}, {
continent: 'Asia',
coordinates: [27.62, 83.11, 180, -19.36],
}, {
continent: 'Australia',
coordinates: [104.87, -6.61, 149.98, -45.87],
}];
To show or hide the control bar, enable or disable the panVisible and zoomVisible properties. You can toggle switches under the map to see how these settings affect the control bar.

DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Angular Vector Map - Dynamic Viewport

This demo illustrates how to change the map's viewport. Use the drop-down menu under the map to choose a continent and change the visible area so that the chosen continent is displayed optimally.

To implement this functionality, call the viewport(viewportCoordinates) method every time the drop-down box value changes. You can also implement the onCenterChanged and onZoomFactorChanged functions to display the map center's coordinates and the current zoom factor in text boxes under the map.

Backend API
<dx-vector-map id="vector-map" #vectorMap [bounds]="[-180, 85, 180, -60]" (onZoomFactorChanged)="zoomChanged($event)" (onCenterChanged)="centerChanged($event)" > <dxi-vector-map-layer [dataSource]="worldMap"></dxi-vector-map-layer> <dxo-vector-map-control-bar [panVisible]="pan.value" [zoomVisible]="zoom.value" > </dxo-vector-map-control-bar> </dx-vector-map> <div class="options"> <div class="caption">Options</div> <div class="wrapper-option"> <div class="column"> <div class="option"> <span>Continent</span> <dx-select-box [dataSource]="viewportData" [width]="210" [inputAttr]="{ 'aria-label': 'Continent' }" displayExpr="continent" valueExpr="coordinates" [value]="viewportData[0].coordinates" (onValueChanged)="onValueChanged($event)" ></dx-select-box> </div> <div class="option"> <span>Zoom factor</span> <dx-text-box [value]="zoomFactorValue" [readOnly]="true" [width]="210" [inputAttr]="{ 'aria-label': 'Zoom' }" > </dx-text-box> </div> <div class="option"> <span>Center</span> <dx-text-box [inputAttr]="{ 'aria-label': 'Center' }" [value]="centerValue" [readOnly]="true" [width]="210" ></dx-text-box> </div> </div> <div class="column"> <div class="option"> <span>Pan control</span> <dx-switch [value]="true" #pan></dx-switch> </div> <div class="option"> <span>Zoom bar</span> <dx-switch [value]="true" #zoom></dx-switch> </div> </div> </div> </div>
import { bootstrapApplication } from '@angular/platform-browser'; import { Component, enableProdMode, ViewChild, provideZoneChangeDetection } from '@angular/core'; import { DxTextBoxModule, DxSwitchModule } from 'devextreme-angular'; import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js'; import { DxSelectBoxModule, DxSelectBoxTypes } from 'devextreme-angular/ui/select-box'; import { DxVectorMapModule, DxVectorMapComponent, DxVectorMapTypes } from 'devextreme-angular/ui/vector-map'; import { ViewportCoordinate, Service } from './app.service'; if (!/localhost/.test(document.location.host)) { enableProdMode(); } let modulePrefix = ''; // @ts-ignore if (window && window.config?.packageConfigPaths) { modulePrefix = '/app'; } @Component({ selector: 'demo-app', providers: [Service], templateUrl: `app/app.component.html`, styleUrls: [`app/app.component.css`], preserveWhitespaces: true, imports: [ DxVectorMapModule, DxSelectBoxModule, DxSwitchModule, DxTextBoxModule, ], }) export class AppComponent { worldMap = mapsData.world; zoomFactorValue = '1.00'; centerValue = '0.000, 46.036'; viewportData: ViewportCoordinate[]; @ViewChild(DxVectorMapComponent, { static: false }) map: DxVectorMapComponent; constructor(service: Service) { this.viewportData = service.getCoordinates(); } onValueChanged(e: DxSelectBoxTypes.ValueChangedEvent) { this.map.instance.viewport(e.value); } zoomChanged(e: DxVectorMapTypes.ZoomFactorChangedEvent) { this.zoomFactorValue = e.zoomFactor.toFixed(2); } centerChanged(e: DxVectorMapTypes.CenterChangedEvent) { this.centerValue = `${e.center[0].toFixed(3) }, ${e.center[1].toFixed(3)}`; } } bootstrapApplication(AppComponent, { providers: [ provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }), ], });
::ng-deep #vector-map { height: 420px; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); margin-top: 20px; } ::ng-deep .wrapper-option { display: flex; gap: 24px; padding-top: 16px; } ::ng-deep .column { display: flex; gap: 10px; flex-direction: column; } .option { display: flex; align-items: center; min-height: 34px; } .caption { font-size: 18px; font-weight: 500; } .option > span { width: 140px; }
import { Injectable } from '@angular/core'; export class ViewportCoordinate { continent: string; coordinates: number[] | 'null'; } const viewportCoordinates: ViewportCoordinate[] = [{ continent: 'all', coordinates: 'null', }, { continent: 'NorthAmerica', coordinates: [-180, 84.52, -22.11, -1.57], }, { continent: 'SouthAmerica', coordinates: [-112.47, 14.26, -27.52, -57.44], }, { continent: 'Africa', coordinates: [-29.34, 39.09, 55.60, -39.00], }, { continent: 'Europe', coordinates: [-2.35, 70.91, 61.35, 35.84], }, { continent: 'Asia', coordinates: [27.62, 83.11, 180, -19.36], }, { continent: 'Australia', coordinates: [104.87, -6.61, 149.98, -45.87], }]; @Injectable() export class Service { getCoordinates(): ViewportCoordinate[] { return viewportCoordinates; } }
// In real applications, you should not transpile code in the browser. // You can see how to create your own application with Angular and DevExtreme here: // https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/ const componentNames = [ 'accordion', 'action-sheet', 'autocomplete', 'bar-gauge', 'box', 'bullet', 'button-group', 'button', 'calendar', 'card-view', 'chart', 'chat', 'check-box', 'circular-gauge', 'color-box', 'context-menu', 'data-grid', 'date-box', 'date-range-box', 'defer-rendering', 'diagram', 'draggable', 'drawer', 'drop-down-box', 'drop-down-button', 'file-manager', 'file-uploader', 'filter-builder', 'form', 'funnel', 'gallery', 'gantt', 'html-editor', 'linear-gauge', 'list', 'load-indicator', 'load-panel', 'lookup', 'map', 'menu', 'multi-view', 'nested', 'number-box', 'pagination', 'pie-chart', 'pivot-grid-field-chooser', 'pivot-grid', 'polar-chart', 'popover', 'popup', 'progress-bar', 'radio-group', 'range-selector', 'range-slider', 'recurrence-editor', 'resizable', 'responsive-box', 'sankey', 'scheduler', 'scroll-view', 'select-box', 'slider', 'sortable', 'sparkline', 'speech-to-text', 'speed-dial-action', 'splitter', 'stepper', 'switch', 'tab-panel', 'tabs', 'tag-box', 'text-area', 'text-box', 'tile-view', 'toast', 'toolbar', 'tooltip', 'tree-list', 'tree-map', 'tree-view', 'validation-group', 'validation-summary', 'validator', 'vector-map', ]; window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, }, meta: { 'typescript': { 'exports': 'ts', }, 'devextreme-dist/js/vectormap-data/*': { 'esModule': true, }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, '@angular/platform-browser-dynamic': { 'esModule': true, }, '@angular/platform-browser': { 'esModule': true, }, '@angular/core': { 'esModule': true, }, '@angular/common': { 'esModule': true, }, '@angular/common/http': { 'esModule': true, }, '@angular/animations': { 'esModule': true, }, '@angular/forms': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', /* @angular */ '@angular/compiler': 'bundles:@angular/compiler.umd.js', '@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js', '@angular/core': 'bundles:@angular/core.umd.js', '@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js', '@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js', '@angular/common': 'bundles:@angular/common.umd.js', '@angular/common/http': 'bundles:@angular/common-http.umd.js', '@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js', '@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js', '@angular/forms': 'bundles:@angular/forms.umd.js', /* devextreme */ 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.25', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.67', /* devextreme-angular umd maps */ 'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js', 'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js', 'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js', 'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js', 'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js', 'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js', 'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js', 'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js', 'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js', 'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js', 'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js', 'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js', 'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js', 'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js', 'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js', 'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js', 'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js', 'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js', ...componentNames.reduce((acc, name) => { acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`; acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`; return acc; }, {}), 'tslib': 'npm:tslib/tslib.js', 'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js', 'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js', 'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', 'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js', }, packages: { 'app': { main: './app.component.ts', defaultExtension: 'ts', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, 'rxjs': { defaultExtension: 'js', }, 'rxjs/operators': { defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:rxjs@7.5.3/package.json', 'npm:rxjs@7.5.3/operators/package.json', 'npm:devexpress-diagram@2.2.25/package.json', 'npm:devexpress-gantt@4.1.67/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line no-console // System.import('@angular/compiler').catch(console.error.bind(console)); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "@angular/core": { "version": "21.0.7" }, "core-js": { "version": "2.6.12" }, "typescript": { "version": "5.9.3" }, "zone.js": { "version": "0.15.1" } };
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script> <script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <script src="config.js"></script> <script> System.import("app").catch(console.error.bind(console)); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <demo-app>Loading...</demo-app> </div> </body> </html>

To show or hide the control bar, enable or disable the panVisible and zoomVisible properties. You can toggle switches under the map to see how these settings affect the control bar.

DevExtreme v24.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Vector Map - Dynamic Viewport

This demo illustrates how to change the map's viewport. Use the drop-down menu under the map to choose a continent and change the visible area so that the chosen continent is displayed optimally.

To implement this functionality, call the viewport(viewportCoordinates) method every time the drop-down box value changes. You can also implement the onCenterChanged and onZoomFactorChanged functions to display the map center's coordinates and the current zoom factor in text boxes under the map.

Backend API
import React, { useCallback, useRef, useState } from 'react'; import VectorMap, { Layer, ControlBar, VectorMapTypes } from 'devextreme-react/vector-map'; import TextBox from 'devextreme-react/text-box'; import SelectBox from 'devextreme-react/select-box'; import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js'; import Switch from 'devextreme-react/switch'; import { viewportCoordinates, centerLabel, zoomLabel, continentLabel, } from './data.ts'; const bounds = [-180, 85, 180, -60]; const App = () => { const [coordinates, setCoordinates] = useState(viewportCoordinates[0].coordinates); const [zoomFactor, setZoomFactor] = useState('1.00'); const [center, setCenter] = useState('0.000, 46.036'); const [panVisible, setPanVisible] = useState(true); const [zoomVisible, setZoomVisible] = useState(true); const mapRef = useRef(null); const continentChanged = useCallback(({ value }) => { setCoordinates(value); mapRef.current.instance().viewport(value); }, [setCoordinates]); const zoomFactorChanged = useCallback((e: VectorMapTypes.ZoomFactorChangedEvent) => { setZoomFactor(e.zoomFactor.toFixed(2)); }, [setZoomFactor]); const centerChanged = useCallback((e: VectorMapTypes.CenterChangedEvent) => { const value = `${e.center[0].toFixed(3)}, ${e.center[1].toFixed(3)}`; setCenter(value); }, [setCenter]); const panVisibleChange = useCallback((value) => { setPanVisible(value); }, [setPanVisible]); const zoomVisibleChange = useCallback((value) => { setZoomVisible(value); }, [setZoomVisible]); return ( <div> <VectorMap id="vector-map" bounds={bounds} ref={mapRef} onZoomFactorChanged={zoomFactorChanged} onCenterChanged={centerChanged} > <ControlBar zoomVisible={zoomVisible} panVisible={panVisible} /> <Layer dataSource={mapsData.world} /> </VectorMap> <div className="options"> <div className="caption">Options</div> <div className="wrapper-option"> <div className="column"> <div className="option"> <span>Continent</span> <SelectBox dataSource={viewportCoordinates} displayExpr="continent" valueExpr="coordinates" inputAttr={continentLabel} value={coordinates} onValueChanged={continentChanged} width={210} /> </div> <div className="option"> <span>Zoom factor</span> <TextBox value={zoomFactor} inputAttr={zoomLabel} readOnly={true} width={210} /> </div> <div className="option"> <span>Center</span> <TextBox value={center} readOnly={true} inputAttr={centerLabel} width={210} /> </div> </div> <div className="column"> <div className="option"> <span>Pan control</span> <Switch value={panVisible} onValueChange={panVisibleChange} /> </div> <div className="option"> <span>Zoom bar</span> <Switch value={zoomVisible} onValueChange={zoomVisibleChange} /> </div> </div> </div> </div> </div> ); }; export default App;
import React, { useCallback, useRef, useState } from 'react'; import VectorMap, { Layer, ControlBar } from 'devextreme-react/vector-map'; import TextBox from 'devextreme-react/text-box'; import SelectBox from 'devextreme-react/select-box'; import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js'; import Switch from 'devextreme-react/switch'; import { viewportCoordinates, centerLabel, zoomLabel, continentLabel, } from './data.js'; const bounds = [-180, 85, 180, -60]; const App = () => { const [coordinates, setCoordinates] = useState(viewportCoordinates[0].coordinates); const [zoomFactor, setZoomFactor] = useState('1.00'); const [center, setCenter] = useState('0.000, 46.036'); const [panVisible, setPanVisible] = useState(true); const [zoomVisible, setZoomVisible] = useState(true); const mapRef = useRef(null); const continentChanged = useCallback( ({ value }) => { setCoordinates(value); mapRef.current.instance().viewport(value); }, [setCoordinates], ); const zoomFactorChanged = useCallback( (e) => { setZoomFactor(e.zoomFactor.toFixed(2)); }, [setZoomFactor], ); const centerChanged = useCallback( (e) => { const value = `${e.center[0].toFixed(3)}, ${e.center[1].toFixed(3)}`; setCenter(value); }, [setCenter], ); const panVisibleChange = useCallback( (value) => { setPanVisible(value); }, [setPanVisible], ); const zoomVisibleChange = useCallback( (value) => { setZoomVisible(value); }, [setZoomVisible], ); return ( <div> <VectorMap id="vector-map" bounds={bounds} ref={mapRef} onZoomFactorChanged={zoomFactorChanged} onCenterChanged={centerChanged} > <ControlBar zoomVisible={zoomVisible} panVisible={panVisible} /> <Layer dataSource={mapsData.world} /> </VectorMap> <div className="options"> <div className="caption">Options</div> <div className="wrapper-option"> <div className="column"> <div className="option"> <span>Continent</span> <SelectBox dataSource={viewportCoordinates} displayExpr="continent" valueExpr="coordinates" inputAttr={continentLabel} value={coordinates} onValueChanged={continentChanged} width={210} /> </div> <div className="option"> <span>Zoom factor</span> <TextBox value={zoomFactor} inputAttr={zoomLabel} readOnly={true} width={210} /> </div> <div className="option"> <span>Center</span> <TextBox value={center} readOnly={true} inputAttr={centerLabel} width={210} /> </div> </div> <div className="column"> <div className="option"> <span>Pan control</span> <Switch value={panVisible} onValueChange={panVisibleChange} /> </div> <div className="option"> <span>Zoom bar</span> <Switch value={zoomVisible} onValueChange={zoomVisibleChange} /> </div> </div> </div> </div> </div> ); }; export default App;
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
export const viewportCoordinates = [{ continent: 'all', coordinates: 'null', }, { continent: 'NorthAmerica', coordinates: [-180, 84.52, -22.11, -1.57], }, { continent: 'SouthAmerica', coordinates: [-112.47, 14.26, -27.52, -57.44], }, { continent: 'Africa', coordinates: [-29.34, 39.09, 55.60, -39.00], }, { continent: 'Europe', coordinates: [-2.35, 70.91, 61.35, 35.84], }, { continent: 'Asia', coordinates: [27.62, 83.11, 180, -19.36], }, { continent: 'Australia', coordinates: [104.87, -6.61, 149.98, -45.87], }]; export const centerLabel = { 'aria-label': 'Center' }; export const zoomLabel = { 'aria-label': 'Zoom' }; export const continentLabel = { 'aria-label': 'Continent' };
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'devextreme-dist/js/vectormap-data/*': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, defaultExtension: 'js', map: { 'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types@15.8.1/prop-types.js', 'devextreme-dist/js/vectormap-data': 'npm:devextreme-dist@24.1.6/js/vectormap-data', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@24.1.6/cjs', 'devextreme-react': 'npm:devextreme-react@24.1.6/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.11/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.56/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.13', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.13/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; System.config(window.config);
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
export const viewportCoordinates = [ { continent: 'all', coordinates: 'null', }, { continent: 'NorthAmerica', coordinates: [-180, 84.52, -22.11, -1.57], }, { continent: 'SouthAmerica', coordinates: [-112.47, 14.26, -27.52, -57.44], }, { continent: 'Africa', coordinates: [-29.34, 39.09, 55.6, -39.0], }, { continent: 'Europe', coordinates: [-2.35, 70.91, 61.35, 35.84], }, { continent: 'Asia', coordinates: [27.62, 83.11, 180, -19.36], }, { continent: 'Australia', coordinates: [104.87, -6.61, 149.98, -45.87], }, ]; export const centerLabel = { 'aria-label': 'Center' }; export const zoomLabel = { 'aria-label': 'Zoom' }; export const continentLabel = { 'aria-label': 'Continent' };
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.1.6/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#vector-map { height: 420px; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); margin-top: 20px; } .wrapper-option { display: flex; gap: 24px; padding-top: 16px; } .column { display: flex; gap: 10px; flex-direction: column; } .option { display: flex; align-items: center; min-height: 34px; } .caption { font-size: 18px; font-weight: 500; } .option > span { width: 140px; }

To show or hide the control bar, enable or disable the panVisible and zoomVisible properties. You can toggle switches under the map to see how these settings affect the control bar.

DevExtreme v24.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Vector Map - Dynamic Viewport

This demo illustrates how to change the map's viewport. Use the drop-down menu under the map to choose a continent and change the visible area so that the chosen continent is displayed optimally.

To implement this functionality, call the viewport(viewportCoordinates) method every time the drop-down box value changes. You can also implement the onCenterChanged and onZoomFactorChanged functions to display the map center's coordinates and the current zoom factor in text boxes under the map.

Backend API
<template> <div> <DxVectorMap id="vector-map" ref="map" :bounds="bounds" @center-changed="centerChanged" @zoom-factor-changed="zoomFactorChanged" > <DxLayer :data-source="world" /> <DxControlBar v-model:pan-visible="panVisible" v-model:zoom-visible="zoomVisible" /> </DxVectorMap> <div class="options"> <div class="caption">Options</div> <div className="wrapper-option"> <div className="column"> <div class="option"> <span>Continent </span> <DxSelectBox :data-source="viewportCoordinates" :value="viewportCoordinates[0].coordinates" :on-value-changed="continentChanged" :input-attr="{ 'aria-label': 'Continent' }" value-expr="coordinates" display-expr="continent" :width="210" /> </div> <div class="option"> <span>Zoom factor </span> <DxTextBox :value="currentZoomFactor" :input-attr="{ 'aria-label': 'Zoom' }" :read-only="true" :width="210" /> </div> <div class="option"> <span>Center </span> <DxTextBox :value="currentCenter" :input-attr="{ 'aria-label': 'Center' }" :read-only="true" :width="210" /> </div> </div> <div className="column"> <div class="option"> <span>Pan control</span> <DxSwitch v-model:value="panVisible"/> </div> <div class="option"> <span>Zoom bar</span> <DxSwitch v-model:value="zoomVisible"/> </div> </div> </div> </div> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import { DxVectorMap, DxLayer, DxControlBar, } from 'devextreme-vue/vector-map'; import DxTextBox from 'devextreme-vue/text-box'; import DxSelectBox from 'devextreme-vue/select-box'; import DxSwitch from 'devextreme-vue/switch'; import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js'; import { viewportCoordinates } from './data.ts'; const world = mapsData.world; const bounds = [-180, 85, 180, -60]; const currentCenter = ref('0.000, 46.036'); const currentZoomFactor = ref('1.00'); const panVisible = ref(true); const zoomVisible = ref(true); const map = ref(); function continentChanged({ value }) { map.value.instance.viewport(value); } function centerChanged({ center }) { currentCenter.value = `${center[0].toFixed(3)}, ${center[1].toFixed(3)}`; } function zoomFactorChanged({ zoomFactor }) { currentZoomFactor.value = zoomFactor.toFixed(2); } </script> <style> #vector-map { height: 420px; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); margin-top: 20px; } .wrapper-option { display: flex; gap: 24px; padding-top: 16px; } .column { display: flex; gap: 10px; flex-direction: column; } .option { display: flex; align-items: center; min-height: 34px; } .caption { font-size: 18px; font-weight: 500; } .option > span { width: 140px; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'devextreme-dist/js/vectormap-data/*': { 'esModule': true, }, }, paths: { 'root:': '../../../../', 'npm:': 'https://unpkg.com/', }, map: { 'vue': 'npm:vue@3.2.47/dist/vue.esm-browser.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js', 'demo-ts-loader': 'root:utils/demo-ts-loader.js', 'svg-loader': 'root:utils/svg-loader.js', 'devextreme-dist/js/vectormap-data': 'npm:devextreme-dist@24.1.6/js/vectormap-data', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@24.1.6/cjs', 'devextreme-vue': 'npm:devextreme-vue@24.1.6/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.11/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.56/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.13', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.13/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; System.config(window.config);
export const viewportCoordinates = [{ continent: 'all', coordinates: 'null', }, { continent: 'NorthAmerica', coordinates: [-180, 84.52, -22.11, -1.57], }, { continent: 'SouthAmerica', coordinates: [-112.47, 14.26, -27.52, -57.44], }, { continent: 'Africa', coordinates: [-29.34, 39.09, 55.60, -39.00], }, { continent: 'Europe', coordinates: [-2.35, 70.91, 61.35, 35.84], }, { continent: 'Asia', coordinates: [27.62, 83.11, 180, -19.36], }, { continent: 'Australia', coordinates: [104.87, -6.61, 149.98, -45.87], }];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.1.6/css/dx.light.css" /> <script src="https://unpkg.com/typescript@4.9.5/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://unpkg.com/@vue/compiler-sfc@3.4.16/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>

To show or hide the control bar, enable or disable the panVisible and zoomVisible properties. You can toggle switches under the map to see how these settings affect the control bar.